/*
dotNetRDF is free and open source software licensed under the MIT License

-----------------------------------------------------------------------------

Copyright (c) 2009-2012 dotNetRDF Project (dotnetrdf-developer@lists.sf.net)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is furnished
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#if NO_WEB

namespace VDS.RDF.Writing
{
    /// <summary>
    /// HTML Attributes
    /// </summary>
    public enum HtmlTextWriterAttribute
    {
        /// <summary>
        /// Access Key
        /// </summary>
        Accesskey,
        /// <summary>
        /// Align
        /// </summary>
        Align,
        /// <summary>
        /// Alternative Text
        /// </summary>
        Alt,
        /// <summary>
        /// Background Image
        /// </summary>
        Background,
        /// <summary>
        /// Background Colour
        /// </summary>
        Bgcolor,
        /// <summary>
        /// Border
        /// </summary>
        Border,
        /// <summary>
        /// Border Colour
        /// </summary>
        Bordercolor,
        /// <summary>
        /// Cell Padding
        /// </summary>
        Cellpadding,
        /// <summary>
        /// Cell Spacing
        /// </summary>
        Cellspacing,
        /// <summary>
        /// Checked
        /// </summary>
        Checked,
        /// <summary>
        /// CSS Class
        /// </summary>
        Class,
        /// <summary>
        /// Columns
        /// </summary>
        Cols,
        /// <summary>
        /// Column Span
        /// </summary>
        Colspan,
        /// <summary>
        /// Disabled
        /// </summary>
        Disabled,
        /// <summary>
        /// For
        /// </summary>
        For,
        /// <summary>
        /// Height
        /// </summary>
        Height,
        /// <summary>
        /// Hyper Reference
        /// </summary>
        Href,
        /// <summary>
        /// ID
        /// </summary>
        Id,
        /// <summary>
        /// Maximum Length
        /// </summary>
        Maxlength,
        /// <summary>
        /// Multiple Values permitted
        /// </summary>
        Multiple,
        /// <summary>
        /// Name
        /// </summary>
        Name,
        /// <summary>
        /// No Wrapping
        /// </summary>
        Nowrap,
        /// <summary>
        /// On Change
        /// </summary>
        Onchange,
        /// <summary>
        /// On Click
        /// </summary>
        Onclick,
        /// <summary>
        /// Read Only
        /// </summary>
        ReadOnly,
        /// <summary>
        /// Rows
        /// </summary>
        Rows,
        /// <summary>
        /// Row Span
        /// </summary>
        Rowspan,
        /// <summary>
        /// Rules
        /// </summary>
        Rules,
        /// <summary>
        /// Selected
        /// </summary>
        Selected,
        /// <summary>
        /// Size
        /// </summary>
        Size,
        /// <summary>
        /// Source
        /// </summary>
        Src,
        /// <summary>
        /// CSS Styles
        /// </summary>
        Style,
        /// <summary>
        /// Tab Index
        /// </summary>
        Tabindex,
        /// <summary>
        /// Target
        /// </summary>
        Target,
        /// <summary>
        /// Title
        /// </summary>
        Title,
        /// <summary>
        /// Type
        /// </summary>
        Type,
        /// <summary>
        /// Vertical Align
        /// </summary>
        Valign,
        /// <summary>
        /// Value
        /// </summary>
        Value,
        /// <summary>
        /// Width
        /// </summary>
        Width,
        /// <summary>
        /// Wrapping
        /// </summary>
        Wrap,
        /// <summary>
        /// Abbreviation
        /// </summary>
        Abbr,
        /// <summary>
        /// Auto-Complete
        /// </summary>
        AutoComplete,
        /// <summary>
        /// Axis
        /// </summary>
        Axis,
        /// <summary>
        /// Content
        /// </summary>
        Content,
        /// <summary>
        /// Coordinates
        /// </summary>
        Coords,
        /// <summary>
        /// Designer Region
        /// </summary>
        DesignerRegion,
        /// <summary>
        /// Direction
        /// </summary>
        Dir,
        /// <summary>
        /// Headers
        /// </summary>
        Headers,
        /// <summary>
        /// Long Description
        /// </summary>
        Longdesc,
        /// <summary>
        /// Relationship
        /// </summary>
        Rel,
        /// <summary>
        /// Scope
        /// </summary>
        Scope,
        /// <summary>
        /// Shape
        /// </summary>
        Shape,
        /// <summary>
        /// Use Map
        /// </summary>
        Usemap,
        /// <summary>
        /// VCard Name
        /// </summary>
        VCardName
    }
}

#endif