/*
dotNetRDF is free and open source software licensed under the MIT License

-----------------------------------------------------------------------------

Copyright (c) 2009-2012 dotNetRDF Project (dotnetrdf-developer@lists.sf.net)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is furnished
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VDS.RDF.Writing.Formatting
{
    /// <summary>
    /// Interface for formatters designed to format entire RDF Graphs
    /// </summary>
    public interface IGraphFormatter : ITripleFormatter
    {
        /// <summary>
        /// Generates the header section for the Graph
        /// </summary>
        /// <param name="g">Graph</param>
        /// <returns></returns>
        String FormatGraphHeader(IGraph g);

        /// <summary>
        /// Generates the header section for the Graph
        /// </summary>
        /// <param name="namespaces">Namespaces</param>
        /// <returns></returns>
        String FormatGraphHeader(INamespaceMapper namespaces);

        /// <summary>
        /// Generates a generic header section
        /// </summary>
        /// <returns></returns>
        String FormatGraphHeader();

        /// <summary>
        /// Generates the footer section
        /// </summary>
        /// <returns></returns>
        String FormatGraphFooter();
    }
}
